/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner{}

// AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner struct for AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner
type AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner struct {
	Label     *string `json:"label,omitempty"`
	ServiceId *string `json:"serviceId,omitempty"`
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner{}
	var label string = "Google Sheets"
	this.Label = &label
	var serviceId string = "google_sheets"
	this.ServiceId = &serviceId
	return &this
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInnerWithDefaults instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInnerWithDefaults() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner{}
	var label string = "Google Sheets"
	this.Label = &label
	var serviceId string = "google_sheets"
	this.ServiceId = &serviceId
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) SetLabel(v string) {
	o.Label = &v
}

// GetServiceId returns the ServiceId field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) GetServiceId() string {
	if o == nil || IsNil(o.ServiceId) {
		var ret string
		return ret
	}
	return *o.ServiceId
}

// GetServiceIdOk returns a tuple with the ServiceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) GetServiceIdOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceId) {
		return nil, false
	}
	return o.ServiceId, true
}

// HasServiceId returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) HasServiceId() bool {
	if o != nil && !IsNil(o.ServiceId) {
		return true
	}

	return false
}

// SetServiceId gets a reference to the given string and assigns it to the ServiceId field.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) SetServiceId(v string) {
	o.ServiceId = &v
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ServiceId) {
		toSerialize["serviceId"] = o.ServiceId
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner struct {
	value *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner
	isSet bool
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) Get() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	return v.value
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) Set(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	return &NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
